# eniM3.py : modele Enigma M3

import string

def C2L(car):
    return string.ascii_uppercase.index(car)

def L2C(lettre):
    return  string.ascii_uppercase[lettre]

class Rotor:
    rotM3 = [
      [  "YRUHQSLDPXNGOKMIEBFZCWVJAT", "A" ],  # 0 - B (reflector)
      [  "EKMFLGDQVZNTOWYHXUSPAIBRCJ", "Q" ],  # 1 - I
      [  "AJDKSIRUXBLHWTMCQGZNPYFVOE", "E" ],  # 2 - II
      [  "BDFHJLCPRTXVZNYEIWGAKMUSQO", "V" ],  # 3 - III
      [  "ESOVPZJAYQUIRHXLNFTGKDCMWB", "J" ],  # 4 - IV
      [  "VZBRGITYUPSDNHLXAWMJQOFECK", "Z" ],  # 5 - V
      [  "JPGVOUMFYQBENHZRDKASXLICTW", "ZM" ], # 6 - VI --- Navy
      [  "NZJHGRCXMYSWBOUFAIVLPEKQDT", "ZM" ], # 7 - VII
      [  "FKQHTLXOCBJSPDZRAMEWNIUYGV", "ZM" ], # 8 - VIII
      [  "FVPJIAOYEDRZXWGCTKUQSBNMHL", "A" ],  # 9 - C (reflector)
      [  "EJMZALYXVBWFCRQUONTSPIKHGD", "A" ],  # 10 -A (reflector)
      [  "YRUHQSLDPXNGOKMIEBFZCWVJAT", "A" ],  # 11 -B (reflector)
      [  "FVPJIAOYEDRZXWGCTKUQSBNMHL", "A" ]   # 12 -C (reflector)
    ]

    def __init__(self,numDuRotor):
        PI = Rotor.rotM3[ numDuRotor ][0]
        les_notchs = Rotor.rotM3[ numDuRotor ][1]
        self.decal = list(range(26))
        self.decal_inv = list(range(26))
        self.Notchs = list(range(26))
        self.ring = 0
        self.index = 0
        tampon = list(range(26))
        for i in range(26):
            indice = C2L(PI[i])
            self.decal[i] = ( indice - i + 26 ) % 26
        for i in range(26):
            tampon[ C2L( PI[i] ) ] = i
        for i in range(26):
            self.decal_inv[i] = ( tampon[i] - i + 26 ) % 26
        for i in range(26):
            self.Notchs[i] = 0
        for i in range(len(les_notchs)):
            self.Notchs[ C2L( les_notchs[i] ) ] = 1

    def setGrund(self,x):
        self.index = x

    def getGrund(self):
        return self.index

    def isCarry(self):
        if ( self.Notchs[self.index]): 
            return 1
        else: 
            return 0

    def setRing(self, x):
        self.ring = x

    def avance(self):
        self.index = (self.index + 1) % 26

    def recule(self):
        self.index = (self.index - 1 + 26) % 26

    def chiffre(self,x):
        return (x + self.decal[ (x + self.index - self.ring + 26)%26 ]) % 26

    def dechiffre(self,x):
        return (x + self.decal_inv[ (x+ self.index - self.ring + 26)%26 ]) % 26


class Stecker:
    def __init__(self,LesSteckers):
        self.s = list(range(26))
        if len(LesSteckers) == 0:
            return
        Steckers = LesSteckers.split(":")
        # print "====> ", len(Steckers), "===>", LesSteckers, "<==="
        for i in range(len(Steckers)):
            # print "+++", Steckers[i]
            x = C2L( Steckers[i][0] )
            y = C2L( Steckers[i][1] )
            self.s[x] = y
            self.s[y] = x

    def setSteck(self, tb):
        self.s = tb

    def getSteck(self):
        return self.s

    def chiffre(self, x):
        return self.s[x]                


class Enigma:
    DoubleStep = 0
    def __init__(self,ukw=0,left=3,middle=2,right=1,stecks="", 
        ring="AAA",grund="AAA", debuging=0):
        self.Debug = debuging
        self.compteur = 0
        self.rotor_right = Rotor(right)
        self.rotor_middle= Rotor(middle)
        self.rotor_left  = Rotor(left)
        self.rotor_reflec= Rotor(ukw)
        self.rotor_right.setGrund(C2L(grund[2]))
        self.rotor_middle.setGrund(C2L(grund[1]))
        self.rotor_left.setGrund(C2L(grund[0]))
        self.rotor_right.setRing(C2L(ring[2]))
        self.rotor_middle.setRing(C2L(ring[1]))
        self.rotor_left.setRing(C2L(ring[0]))
        self.steck = Stecker(stecks)

    def setGrund(self, grund):
        self.rotor_right.setGrund(C2L(grund[2]))
        self.rotor_middle.setGrund(C2L(grund[1]))
        self.rotor_left.setGrund(C2L(grund[0]))

    def encode(self,car):
        lettre = C2L(car)
        self.compteur = self.compteur + 1
        if  self.rotor_middle.isCarry() :
            Enigma.DoubleStep = 1
        if  Enigma.DoubleStep :
            self.rotor_left.avance()
            self.rotor_middle.avance()
            Enigma.DoubleStep = 0
        if  self.rotor_right.isCarry() :
            self.rotor_middle.avance()
        self.rotor_right.avance()
        if self.Debug: 
            print("[%04d]" % (self.compteur), end=' ')
            print("=", end=' ')
            print(L2C(self.rotor_left.getGrund()), end=' ') 
            print(L2C(self.rotor_middle.getGrund()), end=' ') 
            print(L2C(self.rotor_right.getGrund()), end=' ') 
            print("=", L2C(lettre), "->", end=' ')
        lettre = self.steck.chiffre(lettre)
        if self.Debug: print(L2C(lettre),":", end=' ')
        lettre = self.rotor_right.chiffre(lettre)
        if self.Debug: print(L2C(lettre), end=' ')
        lettre = self.rotor_middle.chiffre(lettre)
        if self.Debug: print(L2C(lettre), end=' ')
        lettre = self.rotor_left.chiffre(lettre)
        if self.Debug: print(L2C(lettre), "<", end=' ')
        lettre = self.rotor_reflec.chiffre(lettre)
        if self.Debug: print(L2C(lettre), ">", end=' ')
        lettre = self.rotor_left.dechiffre(lettre)
        if self.Debug: print(L2C(lettre), end=' ')
        lettre = self.rotor_middle.dechiffre(lettre)
        if self.Debug: print(L2C(lettre), end=' ')
        lettre = self.rotor_right.dechiffre(lettre)
        if self.Debug: print(L2C(lettre), end=' ')
        lettre = self.steck.chiffre(lettre)
        if self.Debug: print("->", L2C(lettre))
        return L2C(lettre)

    def decode(self,car):
        return encode( self, car)

#----------------------------------------------------------
if __name__ == '__main__':
    r1 = Rotor(1)
    print(r1.getGrund())
    r1.setGrund(3)
    print(r1.getGrund())
    r1.avance() ; r1.avance()
    print(r1.getGrund())
    print(r1.chiffre(23))
    print(r1.dechiffre(0))

    e = Enigma()
    print(e.encode('H'))

    ch = "A" * 250
    for i in range(1000000):
        ch2 = ""
        for car in ch:
            x = e.encode(car)
            ch2 += x
    print(">", ch2)
